Index: iterators.cs
===================================================================
--- iterators.cs	(revision 63019)
+++ iterators.cs	(working copy)
@@ -71,16 +71,19 @@
 		
 		public override bool Resolve (EmitContext ec)
 		{
+			Report.Debug (64, "RESOLVE YIELD", this, ec, expr, expr.GetType ());
 			expr = expr.Resolve (ec);
 			if (expr == null)
 				return false;
 
+			Report.Debug (64, "RESOLVE YIELD #1", this, ec, expr, expr.GetType (),
+				      ec.CurrentAnonymousMethod, ec.CurrentIterator);
+
 			if (!CheckContext (ec, loc, false))
 				return false;
 
 			Iterator iterator = ec.CurrentIterator;
-
-			if (expr.Type != iterator.IteratorType){
+			if (expr.Type != iterator.IteratorType) {
 				expr = Convert.ImplicitConversionRequired (
 					ec, expr, iterator.IteratorType, loc);
 				if (expr == null)
@@ -119,13 +122,512 @@
 		}
 	}
 
-	public class Iterator : Class {
-		protected ToplevelBlock original_block;
+	public class IteratorHost : AnonymousMethodHost
+	{
+		public readonly Iterator Iterator;
+
+		TypeExpr iterator_type_expr;
+		Field pc_field;
+		Field current_field;
+		Method dispose;
+		MethodInfo dispose_method;
+
+		TypeExpr enumerator_type;
+		TypeExpr enumerable_type;
+		TypeExpr generic_enumerator_type;
+		TypeExpr generic_enumerable_type;
+		TypeArguments generic_args;
+
+		public IteratorHost (Iterator iterator)
+			: base (iterator.Block.CaptureContext, iterator.Block,
+				iterator.Host, iterator.GenericMethod)
+		{
+			this.Iterator = iterator;
+		}
+
+		public MethodInfo Dispose {
+			get { return dispose_method; }
+		}
+
+		public Field PC {
+			get { return pc_field; }
+		}
+
+		public Field CurrentField {
+			get { return current_field; }
+		}
+
+		public Type IteratorType {
+			get { return iterator_type_expr.Type; }
+		}
+
+		public override TypeExpr [] GetClassBases (out TypeExpr base_class)
+		{
+			iterator_type_expr = InflateType (Iterator.OriginalIteratorType);
+
+			generic_args = new TypeArguments (Location);
+			generic_args.Add (iterator_type_expr);
+
+			ArrayList list = new ArrayList ();
+			if (Iterator.IsEnumerable) {
+				enumerable_type = new TypeExpression (
+					TypeManager.ienumerable_type, Location);
+				list.Add (enumerable_type);
+
+				generic_enumerable_type = new ConstructedType (
+					TypeManager.generic_ienumerable_type,
+					generic_args, Location);
+				list.Add (generic_enumerable_type);
+			}
+
+			enumerator_type = new TypeExpression (
+				TypeManager.ienumerator_type, Location);
+			list.Add (enumerator_type);
+
+			list.Add (new TypeExpression (TypeManager.idisposable_type, Location));
+
+			generic_enumerator_type = new ConstructedType (
+				TypeManager.generic_ienumerator_type,
+				generic_args, Location);
+			list.Add (generic_enumerator_type);
+
+			Bases = list;
+
+			return base.GetClassBases (out base_class);
+		}
+
+		protected override bool DoDefineMembers ()
+		{
+			pc_field = CaptureVariable ("$PC", TypeManager.int32_type);
+			current_field = CaptureVariable ("$current", Iterator.OriginalIteratorType);
+
+			Define_Current (true);
+			Define_Current (false);
+			Define_Dispose ();
+			Define_Reset ();
+
+			if (Iterator.IsEnumerable) {
+				Define_GetEnumerator (false);
+				Define_GetEnumerator (true);
+			}
+
+			if (!base.DoDefineMembers ())
+				return false;
+
+			FetchMethodDispose ();
+			return true;
+		}
+
+		protected override void EmitScopeConstructor (EmitContext ec)
+		{
+			ec.ig.Emit (OpCodes.Ldarg_0);
+			ec.ig.Emit (OpCodes.Ldarg_1);
+			ec.ig.Emit (OpCodes.Stfld, pc_field.FieldBuilder);
+			base.EmitScopeConstructor (ec);
+		}
+
+		void FetchMethodDispose ()
+		{
+			MemberList dispose_list;
+
+			dispose_list = FindMembers (
+				CurrentType != null ? CurrentType : TypeBuilder,
+				MemberTypes.Method, BindingFlags.Public | BindingFlags.Instance,
+				Type.FilterName, "Dispose");
+
+			if (dispose_list.Count != 1)
+				throw new InternalErrorException ("Cannot find Dipose() method.");
+
+			dispose_method = (MethodInfo) dispose_list [0];
+		}
+
+		void Define_Current (bool is_generic)
+		{
+			MemberName left;
+			Expression type;
+
+			if (is_generic) {
+				left = new MemberName (
+					"System.Collections.Generic.IEnumerator",
+					generic_args, Location);
+				type = iterator_type_expr;
+			} else {
+				left = new MemberName ("System.Collections.IEnumerator", Location);
+				type = TypeManager.system_object_expr;
+			}
+
+			MemberName name = new MemberName (left, "Current", null, Location);
+
+			ToplevelBlock get_block = new ToplevelBlock (Location);
+			get_block.AddStatement (new CurrentBlock (this, is_generic));
+
+			Accessor getter = new Accessor (get_block, 0, null, Location);
+
+			Property current = new Property (
+				this, type, 0, false, name, null, getter, null);
+			AddProperty (current);
+		}
+
+		void Define_GetEnumerator (bool is_generic)
+		{
+			MemberName left;
+			Expression type;
+			if (is_generic) {
+				left = new MemberName (
+					"System.Collections.Generic.IEnumerable",
+					generic_args, Location);
+				type = generic_enumerator_type;
+			} else {
+				left = new MemberName ("System.Collections.IEnumerable", Location);
+				type = enumerator_type;
+			}
+
+			MemberName name = new MemberName (left, "GetEnumerator", Location);
+
+			Method get_enumerator = new Method (
+				this, null, type, 0, false, name,
+				Parameters.EmptyReadOnlyParameters, null);
+
+			AddMethod (get_enumerator);
+			get_enumerator.Block = new ToplevelBlock (Location);
+			get_enumerator.Block.AddStatement (new GetEnumeratorBlock (this, type, is_generic));
+
+
+#if FIXME
+			Expression ce = new MemberAccess (
+				new SimpleName ("System.Threading.Interlocked", Location),
+				"CompareExchange");
+
+			Expression pc = new FieldExpression (this, pc_field);
+			Expression before = new IntLiteral ((int) State.Running, Location);
+			Expression uninitialized = new IntLiteral ((int) State.Uninitialized, Location);
+
+			ArrayList args = new ArrayList ();
+			args.Add (new Argument (pc, Argument.AType.Ref));
+			args.Add (new Argument (before, Argument.AType.Expression));
+			args.Add (new Argument (uninitialized, Argument.AType.Expression));
+
+			get_enumerator.Block.AddStatement (new If (
+				new Binary (
+					Binary.Operator.Equality,
+					new Invocation (ce, args),
+					uninitialized),
+				new Return (new ThisParameterReference (type.Type, Location),
+					    Location),
+				Location));
+
+			args = new ArrayList ();
+			if (!IsStatic) {
+				args.Add (new Argument (new CapturedThisReference (this, Location)));
+			}
+
+			args.Add (new Argument (new BoolLiteral (true, Location)));
+
+			for (int i = 0; i < parameters.Count; i++) {
+				Expression cp = new CapturedParameterReference (
+					this, parameters.ParameterType (i),
+					parameters.ParameterName (i), Location);
+				args.Add (new Argument (cp));
+			}
+
+			Expression new_expr = new New (current_type, args, Location);
+			get_enumerator.Block.AddStatement (new Return (new_expr, Location));
+#endif
+		}
+
+		void Define_Dispose ()
+		{
+#if FIXME
+			dispose = new Method (
+				this, null, TypeManager.system_void_expr, Modifiers.PUBLIC,
+				false, new MemberName ("Dispose", Location),
+				Parameters.EmptyReadOnlyParameters, null);
+			AddMethod (dispose);
+#else
+			dispose = new DisposeMethod (this);
+#endif
+
+#if FIXME
+			dispose.Block = new ToplevelBlock (null, Location);
+			dispose.Block.SetHaveAnonymousMethods (Location, Iterator);
+			dispose.Block.AddStatement (new DisposeMethod (Iterator, Location));
+#endif
+		}
+
+		void Define_Reset ()
+		{
+			Method reset = new Method (
+				this, null, TypeManager.system_void_expr, Modifiers.PUBLIC,
+				false, new MemberName ("Reset", Location),
+				Parameters.EmptyReadOnlyParameters, null);
+			AddMethod (reset);
+
+			reset.Block = new ToplevelBlock (Location);
+			reset.Block.AddStatement (Create_ThrowNotSupported ());
+		}
+
+		Statement Create_ThrowNotSupported ()
+		{
+			TypeExpr ex_type = new TypeExpression (
+				TypeManager.not_supported_exception_type, Location);
+
+			return new Throw (new New (ex_type, null, Location), Location);
+		}
+
+		ConstructorInfo GetInvalidOperationException ()
+		{
+			MethodGroupExpr mg = (MethodGroupExpr) Expression.MemberLookup (
+				TypeBuilder, TypeManager.invalid_operation_exception_type,
+				".ctor", Location);
+			if (mg == null)
+				throw new InternalErrorException ();
+			return (ConstructorInfo) mg.Methods [0];
+		}
+
+		MethodInfo GetCompareExchange ()
+		{
+			MethodGroupExpr mg = (MethodGroupExpr) Expression.MemberLookup (
+				TypeBuilder, TypeManager.interlocked_type,
+				"CompareExchange", Location);
+			if (mg == null)
+				throw new InternalErrorException ();
+			return (MethodInfo) mg.Methods [0];
+		}
+
+		protected override ScopeInitializerBase CreateScopeInitializer ()
+		{
+			return new IteratorHostInitializer (this);
+		}
+
+		protected class IteratorHostInitializer : AnonymousMethodHostInitializer
+		{
+			new public readonly IteratorHost Host;
+			protected Iterator.State state;
+
+			public IteratorHostInitializer (IteratorHost host)
+				: base (host)
+			{
+				this.Host = host;
+			}
+
+			protected override bool DoResolveInternal (EmitContext ec)
+			{
+				if (this is EnumeratorScopeInitializer)
+					state = Iterator.State.Running;
+				else if (Host.Iterator.IsEnumerable)
+					state = Iterator.State.Uninitialized;
+				else
+					state = Iterator.State.Running;
+
+				return base.DoResolveInternal (ec);
+			}
+
+			protected override void EmitScopeConstructor (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Ldc_I4, (int) state);
+				base.EmitScopeConstructor (ec);
+			}
+		}
+
+		protected class DisposeMethod : Method
+		{
+			public IteratorHost Host;
+
+			public DisposeMethod (IteratorHost host)
+				: base (host, null, TypeManager.system_void_expr, Modifiers.PUBLIC,
+					false, new MemberName ("Dispose", host.Location),
+					Parameters.EmptyReadOnlyParameters, null)
+			{
+				this.Host = host;
+
+				host.AddMethod (this);
+
+				Block = new ToplevelBlock (host.Iterator.Container, null, Location);
+				// Block.SetHaveAnonymousMethods (Location, Host.Iterator);
+
+				// Block = Host.Iterator.DisposeBlock;
+
+				// Block = new ToplevelBlock (Location);
+				// Block.SetHaveAnonymousMethods (Location, Host.Iterator);
+
+				Block.AddStatement (new DisposeMethodStatement (Host.Iterator));
+
+				Report.Debug (64, "DISPOSE METHOD", host, Block);
+			}
+
+			public override EmitContext CreateEmitContext (DeclSpace tc, ILGenerator ig)
+			{
+				EmitContext ec = new EmitContext (
+					this, tc, this.ds, Location, ig, MemberType, ModFlags, false);
+
+				ec.capture_context = Host.Iterator.Block.CaptureContext;
+				ec.CurrentAnonymousMethod = Host.Iterator;
+				return ec;
+			}
+
+			protected class DisposeMethodStatement : Statement
+			{
+				Iterator iterator;
+
+				public DisposeMethodStatement (Iterator iterator)
+				{
+					this.iterator = iterator;
+					this.loc = iterator.Location;
+				}
+
+				public override bool Resolve (EmitContext ec)
+				{
+					return true;
+				}
+
+				protected override void DoEmit (EmitContext ec)
+				{
+					iterator.EmitDispose (ec);
+				}
+			}
+		}
+
+		protected ScopeInitializer GetEnumeratorInitializer (EmitContext ec)
+		{
+			ScopeInitializer init = new EnumeratorScopeInitializer (this);
+			if (init.Resolve (ec) == null)
+				throw new InternalErrorException ();
+			return init;
+		}
+
+		protected class EnumeratorScopeInitializer : IteratorHostInitializer
+		{
+			IteratorHost host;
+			ExpressionStatement initializer;
+
+			public EnumeratorScopeInitializer (IteratorHost host)
+				: base (host)
+			{
+				this.host = host;
+			}
+
+			protected override bool DoResolveInternal (EmitContext ec)
+			{
+				initializer = host.GetScopeInitializer (ec);
+				type = host.IsGeneric ? host.CurrentType : host.TypeBuilder;
+				return base.DoResolveInternal (ec);
+			}
+
+			protected override void EmitParameterReference (EmitContext ec,
+									CapturedParameter cp)
+			{
+				Report.Debug (64, "EMIT THE PARAM", this, cp, host,
+					      initializer, host.CaptureContext.captured_parameters);
+				ec.ig.Emit (OpCodes.Ldarg_0);
+				ec.ig.Emit (OpCodes.Ldfld, cp.Field.FieldBuilder);
+			}
+		}
+
+		protected class CurrentBlock : Statement {
+			IteratorHost host;
+			bool is_generic;
+
+			public CurrentBlock (IteratorHost host, bool is_generic)
+			{
+				this.host = host;
+				this.is_generic = is_generic;
+				loc = host.Location;
+			}
+
+			public override bool Resolve (EmitContext ec)
+			{
+				ec.CurrentBranching.CurrentUsageVector.Return ();
+				return true;
+			}
+
+			protected override void DoEmit (EmitContext ec)
+			{
+				ILGenerator ig = ec.ig;
+				Label label_ok = ig.DefineLabel ();
+
+				ig.Emit (OpCodes.Ldarg_0);
+				ig.Emit (OpCodes.Ldfld, host.PC.FieldBuilder);
+				ig.Emit (OpCodes.Ldc_I4, (int) Iterator.State.Running);
+				ig.Emit (OpCodes.Bgt, label_ok);
+
+				ig.Emit (OpCodes.Newobj, host.GetInvalidOperationException ());
+				ig.Emit (OpCodes.Throw);
+
+				ig.MarkLabel (label_ok);
+				ig.Emit (OpCodes.Ldarg_0);
+				ig.Emit (OpCodes.Ldfld, host.CurrentField.FieldBuilder);
+				if (!is_generic)
+					ig.Emit (OpCodes.Box, host.CurrentField.MemberType);
+				ig.Emit (OpCodes.Ret);
+			}
+		}
+
+		protected class GetEnumeratorBlock : Statement {
+			IteratorHost host;
+			Expression type;
+			bool is_generic;
+
+			Expression initializer, cast;
+			MethodInfo ce;
+
+			public GetEnumeratorBlock (IteratorHost host, Expression type,
+						   bool is_generic)
+			{
+				this.host = host;
+				this.type = type;
+				this.is_generic = is_generic;
+				loc = host.Location;
+			}
+
+			public override bool Resolve (EmitContext ec)
+			{
+				type = type.ResolveAsTypeTerminal (ec, false);
+				if ((type == null) || (type.Type == null))
+					return false;
+
+				initializer = host.GetEnumeratorInitializer (ec);
+				if (initializer == null)
+					return false;
+
+				cast = new ClassCast (initializer, type.Type);
+
+				ce = host.GetCompareExchange ();
+
+				ec.CurrentBranching.CurrentUsageVector.Return ();
+				return true;
+			}
+
+			protected override void DoEmit (EmitContext ec)
+			{
+				ILGenerator ig = ec.ig;
+				Label label_init = ig.DefineLabel ();
+
+				ig.Emit (OpCodes.Ldarg_0);
+				ig.Emit (OpCodes.Ldflda, host.PC.FieldBuilder);
+				ig.Emit (OpCodes.Ldc_I4, (int) Iterator.State.Running);
+				ig.Emit (OpCodes.Ldc_I4, (int) Iterator.State.Uninitialized);
+				ig.Emit (OpCodes.Call, ce);
+
+				ig.Emit (OpCodes.Ldc_I4, (int) Iterator.State.Uninitialized);
+				ig.Emit (OpCodes.Bne_Un, label_init);
+
+				ig.Emit (OpCodes.Ldarg_0);
+				ig.Emit (OpCodes.Ret);
+
+				ig.MarkLabel (label_init);
+
+				cast.Emit (ec);
+				ig.Emit (OpCodes.Ret);
+			}
+		}
+	}
+
+	public class Iterator : AnonymousContainer {
+		protected readonly ToplevelBlock OriginalBlock;
+		protected readonly IMethodData OriginalMethod;
 		protected ToplevelBlock block;
 
-		Type original_iterator_type;
-		TypeExpr iterator_type_expr;
-		bool is_enumerable;
+		public readonly bool IsEnumerable;
 		public readonly bool IsStatic;
 
 		//
@@ -139,7 +641,6 @@
 		// Context from the original method
 		//
 		GenericMethod generic_method;
-		TypeContainer container;
 		TypeExpr current_type;
 		Type this_type;
 		Parameters parameters;
@@ -147,7 +648,7 @@
 		IMethodData orig_method;
 
 		MethodInfo dispose_method;
-		MoveNextMethod move_next_method;
+		Method move_next_method;
 		Constructor ctor;
 		CaptureContext cc;
 
@@ -156,25 +657,25 @@
 		Expression generic_enumerator_type;
 		Expression generic_enumerable_type;
 		TypeArguments generic_args;
-		EmitContext ec;
 
-		protected enum State {
+		public readonly Type OriginalIteratorType;
+		public readonly IteratorHost IteratorHost;
+
+		public enum State {
 			Uninitialized	= -2,
 			After,
 			Running
 		}
 
-		static int proxy_count;
-
 		public void EmitYieldBreak (ILGenerator ig)
 		{
 			ig.Emit (OpCodes.Ldarg_0);
 			IntConstant.EmitInt (ig, (int) State.After);
-			ig.Emit (OpCodes.Stfld, pc_field.FieldBuilder);
+			ig.Emit (OpCodes.Stfld, IteratorHost.PC.FieldBuilder);
 			ig.Emit (OpCodes.Br, move_next_error);
 		}
 
-		public void EmitMoveNext (EmitContext ec)
+		internal void EmitMoveNext (EmitContext ec, Block original_block)
 		{
 			ILGenerator ig = ec.ig;
 
@@ -192,7 +693,7 @@
 			resume_points.Add (entry_point);
 			entry_point.Define (ig);
 
-			ec.EmitTopBlock (orig_method, original_block);
+			original_block.Emit (ec);
 
 			EmitYieldBreak (ig);
 
@@ -203,7 +704,7 @@
 				labels [i] = ((ResumePoint) resume_points [i]).Label;
 
 			ig.Emit (OpCodes.Ldarg_0);
-			ig.Emit (OpCodes.Ldfld, pc_field.FieldBuilder);
+			ig.Emit (OpCodes.Ldfld, IteratorHost.PC.FieldBuilder);
 			ig.Emit (OpCodes.Switch, labels);
 
 			Label end = ig.DefineLabel ();
@@ -221,7 +722,7 @@
 			ig.BeginFaultBlock ();
 
 			ig.Emit (OpCodes.Ldarg_0);
-			ig.Emit (OpCodes.Callvirt, dispose_method);
+			ig.Emit (OpCodes.Callvirt, IteratorHost.Dispose);
 
 			ig.EndExceptionBlock ();
 
@@ -264,12 +765,12 @@
 
 			ig.MarkLabel (dispatcher);
 			ig.Emit (OpCodes.Ldarg_0);
-			ig.Emit (OpCodes.Ldfld, pc_field.FieldBuilder);
+			ig.Emit (OpCodes.Ldfld, IteratorHost.PC.FieldBuilder);
 			ig.Emit (OpCodes.Switch, labels);
 
 			ig.Emit (OpCodes.Ldarg_0);
 			IntConstant.EmitInt (ig, (int) State.After);
-			ig.Emit (OpCodes.Stfld, pc_field.FieldBuilder);
+			ig.Emit (OpCodes.Stfld, IteratorHost.PC.FieldBuilder);
 
 			ig.MarkLabel (end);
 		}
@@ -305,13 +806,13 @@
 			// Store the new current
 			ig.Emit (OpCodes.Ldarg_0);
 			expr.Emit (ec);
-			ig.Emit (OpCodes.Stfld, current_field.FieldBuilder);
+			ig.Emit (OpCodes.Stfld, IteratorHost.CurrentField.FieldBuilder);
 
 			// increment pc
 			pc++;
 			ig.Emit (OpCodes.Ldarg_0);
 			IntConstant.EmitInt (ig, pc);
-			ig.Emit (OpCodes.Stfld, pc_field.FieldBuilder);
+			ig.Emit (OpCodes.Stfld, IteratorHost.PC.FieldBuilder);
 
 			// Return ok
 			ig.Emit (OpCodes.Br, move_next_ok);
@@ -329,75 +830,103 @@
 			pc++;
 			ig.Emit (OpCodes.Ldarg_0);
 			IntConstant.EmitInt (ig, pc);
-			ig.Emit (OpCodes.Stfld, pc_field.FieldBuilder);
+			ig.Emit (OpCodes.Stfld, IteratorHost.PC.FieldBuilder);
 
 			ResumePoint point = new ResumePoint (finally_blocks);
 			resume_points.Add (point);
 			point.Define (ig);
 		}
 
-		private static MemberName MakeProxyName (string name, GenericMethod generic, Location loc)
-		{
-			int pos = name.LastIndexOf ('.');
-			if (pos > 0)
-				name = name.Substring (pos + 1);
+		public override bool IsIterator {
+			get { return true; }
+		}
 
-			string proxy_name = "<" + name + ">__" + (proxy_count++);
-
-			if (generic != null) {
-				TypeArguments args = new TypeArguments (loc);
-				foreach (TypeParameter tparam in generic.CurrentTypeParameters)
-					args.Add (new SimpleName (tparam.Name, loc));
-				return new MemberName (proxy_name, args, loc);
-			} else
-				return new MemberName (proxy_name, loc);
+		public override AnonymousMethodHost RootScope {
+			get { return IteratorHost; }
 		}
 
+		ToplevelBlock TheBlock;
+		// public ToplevelBlock DisposeBlock;
+
 		//
 		// Our constructor
 		//
-		public Iterator (IMethodData m_container, DeclSpace parent, GenericMethod generic,
-				 int modifiers)
-			: base (parent.NamespaceEntry, parent,
-				MakeProxyName (m_container.MethodName.Name, generic, m_container.Location),
-				(modifiers & Modifiers.UNSAFE) | Modifiers.PRIVATE, null)
+		public Iterator (IMethodData m_container, TypeContainer host, GenericMethod generic,
+				 ToplevelBlock container, ToplevelBlock block, int modifiers,
+				 Type iterator_type, bool is_enumerable)
+			: base (null, host, generic, m_container.ParameterInfo,
+				block, m_container.Block, TypeManager.bool_type, modifiers,
+				m_container.Location)
 		{
-			this.orig_method = m_container;
+			this.OriginalBlock = m_container.Block;
+			this.OriginalMethod = m_container;
+			this.OriginalIteratorType = iterator_type;
+			this.IsEnumerable = is_enumerable;
+			this.TheBlock = block;
 
-			this.generic_method = generic;
-			this.container = ((TypeContainer) parent).PartialContainer;
-			this.original_parameters = m_container.ParameterInfo;
-			this.original_block = orig_method.Block;
-			this.block = new ToplevelBlock (orig_method.Block, parameters, orig_method.Location);
+			// Block.ReParent (Container);
 
-			if (generic != null) {
-				ArrayList constraints = new ArrayList ();
-				foreach (TypeParameter tparam in generic.TypeParameters)
-					constraints.Add (tparam.Constraints);
+			// Container.SetHaveAnonymousMethods (Location, this);
+			Block.SetHaveAnonymousMethods (Location, this);
 
-				SetParameterInfo (constraints);
+			// DisposeBlock = new ToplevelBlock (Block, null, Location);
+			// DisposeBlock.SetHaveAnonymousMethods (Location, this);
+
+			// OriginalBlock.ReParent (Block);
+			// OriginalBlock.SetHaveAnonymousMethods (Location, this);
+
+			Report.Debug (64, "NEW ITERATOR", host, generic, OriginalBlock,
+				      Container, Block, block);
+
+			IteratorHost = new IteratorHost (this);
+			Block.CreateIteratorHost (IteratorHost);
+
+			OriginalBlock.ReParent (Container);
+
+			m_container.Block = TheBlock;
+			// block.AddStatement (new TestStatement ());
+
+			OriginalBlock.MakeIterator (this);
+
+			// MoveNextStatement inline = new MoveNextStatement (this, Location);
+			// Container.AddStatement (inline);
+		}
+
+		protected class TestStatement : Statement
+		{
+			public override bool Resolve (EmitContext ec)
+			{
+				return true;
 			}
 
-			IsStatic = (modifiers & Modifiers.STATIC) != 0;
+			protected override void DoEmit (EmitContext ec)
+			{
+				ec.ig.Emit (OpCodes.Nop);
+				ec.ig.Emit (OpCodes.Neg);
+				ec.ig.Emit (OpCodes.Pop);
+				ec.ig.Emit (OpCodes.Ret);
+			}
 		}
 
-		public AnonymousContainer Host {
-			get { return move_next_method; }
+		protected override CaptureContext ContainerCaptureContext {
+			get { return OriginalBlock.CaptureContext; }
 		}
 
-		public bool DefineIterator ()
+		protected override CaptureContext CaptureContext {
+			get { return OriginalBlock.CaptureContext; }
+		}
+
+#if FIXME
+		public override ConstructorInfo Constructor {
+			get { return ctor.ConstructorBuilder; }
+		}
+
+		protected bool DefineIterator ()
 		{
 			ec = new EmitContext (this, this, Location, null, null, ModFlags);
-			ec.CurrentAnonymousMethod = move_next_method;
+			ec.CurrentAnonymousMethod = this;
 			ec.InIterator = true;
 
-			if (!CheckType ()) {
-				Report.Error (1624, Location,
-					"The body of `{0}' cannot be an iterator block because `{1}' is not an iterator interface type",
-					orig_method.GetSignatureForError (), TypeManager.CSharpName (orig_method.ReturnType));
-				return false;
-			}
-
 			for (int i = 0; i < original_parameters.Count; i++){
 				Parameter.Modifier mod = original_parameters.ParameterModifier (i);
 				if ((mod & (Parameter.Modifier.REF | Parameter.Modifier.OUT)) != 0){
@@ -423,12 +952,50 @@
 			else
 				this_type = container.TypeBuilder;
 
-			container.AddIterator (this);
+			orig_method.Block = block;
 
-			orig_method.Block = block;
+			return Resolve (ec);
+		}
+#endif
+
+		public override bool Resolve (EmitContext ec)
+		{
+			Report.Debug (64, "RESOLVE ITERATOR", this, Container, Block, TheBlock);
+
+			if (!base.Resolve (ec))
+				return false;
+
+			Report.Debug (64, "RESOLVE ITERATOR #1", this, method, method.Parent, RootScope);
+
+			if (!RootScope.DefineMembers ())
+				return false;
+
+			Expression scope_init = RootScope.GetScopeInitializer (ec);
+			Expression cast = new ClassCast (scope_init, OriginalMethod.ReturnType);
+			Container.AddStatement (new NoCheckReturn (cast));
+
 			return true;
 		}
 
+		protected override Method DoCreateMethodHost (EmitContext ec)
+		{
+			return new AnonymousMethodMethod (
+				this, null, TypeManager.system_boolean_expr,
+				Modifiers.PUBLIC, new MemberName ("MoveNext", Location),
+				Parameters.EmptyReadOnlyParameters);
+		}
+
+#if FIXME
+
+		public override CompilerGeneratedClass CreateScopeType (ScopeInfo scope)
+		{
+			return this;
+		}
+
+		public override bool IsIterator {
+			get { return true; }
+		}
+
 		MethodInfo FetchMethodDispose ()
 		{
 			MemberList dispose_list;
@@ -447,7 +1014,7 @@
 		protected override bool DoDefineMembers ()
 		{
 			ec.InIterator = true;
-			ec.CurrentAnonymousMethod = move_next_method;
+			ec.CurrentAnonymousMethod = this;
 			ec.capture_context = cc;
 
 			if (!base.DoDefineMembers ())
@@ -457,6 +1024,8 @@
 			if (dispose_method == null)
 				return false;
 
+			Report.Debug (64, "ITERATOR DEFINE MEMBERS", this);
+
 			return true;
 		}
 
@@ -466,7 +1035,7 @@
 				return false;
 
 			ec.InIterator = true;
-			ec.CurrentAnonymousMethod = move_next_method;
+			ec.CurrentAnonymousMethod = this;
 			ec.capture_context = cc;
 
 			ec.TypeContainer = ec.TypeContainer.Parent;
@@ -476,7 +1045,7 @@
 			else
 				ec.ContainerType = ec.TypeContainer.TypeBuilder;
 
-			ec.ig = move_next_method.method.MethodBuilder.GetILGenerator ();
+			// ec.ig = move_next_method.method.MethodBuilder.GetILGenerator ();
 
 			if (!ctor.Define ())
 				return false;
@@ -489,38 +1058,13 @@
 			if (!ec.ResolveTopBlock (null, block, parameters, orig_method, out unreachable))
 				return false;
 
-			original_block.CompleteContexts ();
+			original_block.CompleteContexts (ec);
 
 			cc.EmitAnonymousHelperClasses (ec);
 
-			return true;
-		}
+			ComputeMethodHost ();
 
-		TypeExpr InflateType (Type it)
-		{
-			if (generic_method == null)
-				return new TypeExpression (it, Location);
-
-			if (it.IsGenericParameter && (it.DeclaringMethod != null)) {
-				int pos = it.GenericParameterPosition;
-				it = CurrentTypeParameters [pos].Type;
-			} else if (it.IsGenericType) {
-				Type[] args = it.GetGenericArguments ();
-
-				TypeArguments inflated = new TypeArguments (Location);
-				foreach (Type t in args)
-					inflated.Add (InflateType (t));
-
-				return new ConstructedType (it, inflated, Location);
-			} else if (it.IsArray) {
-				TypeExpr et_expr = InflateType (it.GetElementType ());
-				int rank = it.GetArrayRank ();
-
-				Type et = et_expr.ResolveAsTypeTerminal (ec, false).Type;
-				it = et.MakeArrayType (rank);
-			}
-
-			return new TypeExpression (it, Location);
+			return DefineMembers ();
 		}
 
 		Parameter InflateParameter (Parameter param)
@@ -587,11 +1131,6 @@
 			else
 				current_type = new TypeExpression (TypeBuilder, Location);
 
-			if (IsGeneric) {
-				foreach (TypeParameter tparam in TypeParameters)
-					tparam.InflateConstraints (current_type.Type);
-			}
-
 			parameters = InflateParameters (original_parameters, ec);
 			if (!parameters.Resolve (ec)) {
 				// TODO:
@@ -600,7 +1139,6 @@
 			Define_Fields ();
 			Define_Current (false);
 			Define_Current (true);
-			Define_MoveNext ();
 			Define_Reset ();
 			Define_Dispose ();
 
@@ -616,14 +1154,12 @@
 			return base.DefineNestedTypes ();
 		}
 
-		Field pc_field;
-		Field current_field;
 		Method dispose;
 
 		void Create_Block ()
 		{
-			original_block.SetHaveAnonymousMethods (Location, move_next_method);
-			block.SetHaveAnonymousMethods (Location, move_next_method);
+			original_block.SetHaveAnonymousMethods (Location, this);
+			block.SetHaveAnonymousMethods (Location, this);
 
 			cc = original_block.CaptureContext;
 
@@ -634,7 +1170,7 @@
 				Type t = this_type;
 				args.Add (new Argument (
 					new ThisParameterReference (t, Location)));
-				cc.CaptureThis (move_next_method);
+				cc.CaptureThis (this);
 			}
 
 			args.Add (new Argument (new BoolLiteral (false, Location)));
@@ -647,7 +1183,11 @@
 				args.Add (new Argument (
 					new SimpleParameterReference (t, first + i, Location)));
 
-				cc.AddParameterToContext (move_next_method, name, inflated, first + i);
+				Report.Debug (64, "ITERATOR ADD PARAMETER", this, i, t, name,
+					      inflated);
+
+				cc.AddParameterToContext (
+					this, parameters [i], first + i, Location);
 			}
 
 			TypeExpr proxy_type;
@@ -665,7 +1205,7 @@
 				proxy_type = current_type;
 
 			Expression new_expr = new New (proxy_type, args, Location);
-			block.AddStatement (new NoCheckReturn (new_expr, Location));
+			block.AddStatement (new NoCheckReturn (new_expr));
 		}
 
 		void Define_Fields ()
@@ -723,7 +1263,8 @@
 				new SetState (this, State.Running, Location),
 				Location));
 
-			ctor.Block.AddStatement (new InitScope (this, Location));
+			ExpressionStatement init_scope = GetScopeInitializer (Location);
+			ctor.Block.AddStatement (new StatementExpression (init_scope));
 		}
 
 		Statement Create_ThrowInvalidOperation ()
@@ -778,17 +1319,6 @@
 			AddProperty (current);
 		}
 
-		void Define_MoveNext ()
-		{
-			move_next_method = new MoveNextMethod (this, Location);
-
-			original_block.ReParent (block, move_next_method);
-
-			move_next_method.CreateMethod (ec);
-
-			AddMethod (move_next_method.method);
-		}
-
 		void Define_GetEnumerator (bool is_generic)
 		{
 			MemberName left;
@@ -820,7 +1350,7 @@
 			get_enumerator.Block = new ToplevelBlock (
 				block, parameters, Location);
 
-			get_enumerator.Block.SetHaveAnonymousMethods (Location, move_next_method);
+			get_enumerator.Block.SetHaveAnonymousMethods (Location, this);
 
 			Expression ce = new MemberAccess (
 				new SimpleName ("System.Threading.Interlocked", Location),
@@ -934,7 +1464,7 @@
 
 			public override void Emit (EmitContext ec)
 			{
-				ec.CurrentAnonymousMethod = iterator.move_next_method;
+				ec.CurrentAnonymousMethod = iterator;
 
 				LocalTemporary dummy = null;
 				
@@ -995,62 +1525,8 @@
 				throw new InvalidOperationException ();
 			}
 		}
+#endif
 
-		protected class MoveNextMethod : AnonymousContainer
-		{
-			Iterator iterator;
-
-			public MoveNextMethod (Iterator iterator, Location loc)
-				: base (iterator.parameters, iterator.original_block, loc)
-			{
-				this.iterator = iterator;
-			}
-
-			protected override bool CreateMethodHost (EmitContext ec)
-			{
-				method = new Method (
-					iterator, null, TypeManager.system_boolean_expr,
-					Modifiers.PUBLIC, false, new MemberName ("MoveNext", loc),
-					Parameters.EmptyReadOnlyParameters, null);
-
-				method.Block = Block;
-
-				MoveNextStatement inline = new MoveNextStatement (iterator, loc);
-				Block.AddStatement (inline);
-
-				return true;
-			}
-
-			public bool CreateMethod (EmitContext ec)
-			{
-				return CreateMethodHost (ec);
-			}
-
-			public override Iterator Iterator {
-				get { return iterator; }
-			}
-
-			public void ComputeHost ()
-			{
-				ComputeMethodHost ();
-			}
-			
-			public override bool IsIterator {
-				get { return true; }
-			}
-
-			public override void CreateScopeType (EmitContext ec, ScopeInfo scope)
-			{
-				scope.ScopeTypeBuilder = iterator.TypeBuilder;
-				scope.ScopeConstructor = iterator.ctor.ConstructorBuilder;
-			}
-
-			public override void Emit (EmitContext ec)
-			{
-				throw new InternalErrorException ();
-			}
-		}
-
 		protected class MoveNextStatement : Statement {
 			Iterator iterator;
 
@@ -1062,19 +1538,16 @@
 
 			public override bool Resolve (EmitContext ec)
 			{
-				return true;
+				return iterator.OriginalBlock.Resolve (ec);
 			}
 
 			protected override void DoEmit (EmitContext ec)
 			{
-				iterator.move_next_method.ComputeHost ();
-				ec.CurrentAnonymousMethod = iterator.move_next_method;
-				ec.InIterator = true;
-
-				iterator.EmitMoveNext (ec);
+				iterator.EmitMoveNext (ec, iterator.Block);
 			}
 		}
 
+#if FIXME
 		protected class DisposeMethod : Statement {
 			Iterator iterator;
 
